local set = krework.chars.tails.settings

function A_KRTailsThrow(mo)
	local thrown = mo.krework.tails.throwplayer
	if not thrown
		print("no throwplayer")
		return
	end
	
	-- Reverse Pythagoras, Tails throws up/down at a 45 degree angle
	local forcecomp = FixedSqrt(FixedMul(set.THROW_FORCE,set.THROW_FORCE)/2)
	
	if (mo.krework.tails.throwup) and not (mo.krework.tails.throwdown)
		P_SetObjectMomZ(thrown.mo, forcecomp, false)
		P_Thrust(thrown.mo, mo.angle, forcecomp)
		thrown.pflags = $ | PF_JUMPDOWN
	elseif (mo.krework.tails.throwdown) and not (mo.krework.tails.throwup)
		P_SetObjectMomZ(thrown.mo, -forcecomp, false)
		P_Thrust(thrown.mo, mo.angle, forcecomp)
		thrown.pflags = $ | PF_USEDOWN
	elseif (mo.krework.tails.throwup) and (mo.krework.tails.throwdown)
		P_InstaThrust(thrown.mo, mo.angle, set.THROW_FORCE)
		P_SetObjectMomZ(thrown.mo, 10*FRACUNIT, false)
		thrown.pflags = $ | PF_JUMPDOWN | PF_USEDOWN
	end
	
	A_KRAircurl(thrown)
	A_KRResetAbilities(thrown)
	mo.krework.tails.throwplayer = nil
	
	if mo.player.cmd.buttons & BT_JUMP
		mo.state = S_PLAY_FLYBOOST
	end
end

-- Tails flight activated
function A_KRTailsFly(mo)
	local player = mo.player
	
	mo.krework.tails.throwplayer = krework.getNearbyAlly(mo, set.MAX_GRAB_RANGE)
	if mo.krework.tails.throwplayer and mo.krework.tails.throwtime == 0
		mo.state = S_PLAY_TAILSCATCH
		
		local whirl1 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_TAILS_WHIRLYGIG)
		whirl1.color = mo.color
		whirl1.colorized = true
		whirl1.target = mo
		whirl1.angle = mo.angle + ANGLE_90
		
		local whirl2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_TAILS_WHIRLYGIG)
		whirl2.color = mo.krework.tails.throwplayer.mo.color
		whirl2.colorized = true
		whirl2.target = mo
		whirl2.angle = mo.angle + ANGLE_270
		return
	end
	
	local speed = FixedHypot(mo.momx, mo.momy)
	local momangle = R_PointToAngle2(0, 0, mo.momx, mo.momy)
	
	-- Momentum
	mo.momz = $ / 2
	P_Thrust(mo, momangle + ANGLE_180, speed / 4)
	
	-- Super Tails: Spawn a whirlwind if this is your first flight
//	if 
//	player.powers[super] and
//	mo.krework.tails.flycount == set.BOOST_COUNT
//	and not (mo.eflags & MFE_UNDERWATER)
//	and not player.krework.tempobj
//		player.krework.tempobj = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_TAILSWIND)
//		player.krework.tempobj.lifespan = set.SUPER_NADO_LIFE
//		player.krework.tempobj.flags = $ | MF_NOCLIP
//		player.krework.tempobj.color = player.mo.color
//		player.krework.tempobj.colorized = true
//	end
	
	-- Flags, states
	mo.krework.tails.flytime = 0
	mo.krework.tails.flycount = (mo.eflags & MFE_UNDERWATER) and set.BOOST_COUNT or ($1 - 1)
	player.pflags = $ | PF_NOJUMPDAMAGE
	player.pflags = $ & ~PF_SPINNING
	
	-- Sound effect
	if not (mo.eflags & MFE_UNDERWATER)
		S_StartSound(mo, sfx_putput)
	end
end
