local WHIRLYGIG_ROTATIONS = 3

-- Action for non-standard ability states
local function setAbilityAnim(mo)
	mo.player.panim = PA_ABILITY
end

states[S_PLAY_FLYBOOST] = {action = A_KRTailsFly,
	sprite = SPR_PLAY,
	frame = SPR2_FLY,
	tics = 0,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_FLYHOVER
}

states[S_PLAY_FLYHOVER] = {action = setAbilityAnim,
	sprite = SPR_PLAY,
	frame = SPR2_FLY,
	tics = 2,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_FLYHOVER
}

states[S_PLAY_FLYHOVER_TIRED] = {action = setAbilityAnim,
	sprite = SPR_PLAY,
	frame = SPR2_TIRE,
	tics = 12,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_FLYHOVER_TIRED
}

states[S_PLAY_SWIMHOVER] = {action = setAbilityAnim,
	sprite = SPR_PLAY,
	frame = SPR2_SWIM,
	tics = 4,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_SWIMHOVER
}

states[S_PLAY_TAILSCATCH] = {action = nil,
	sprite = SPR_NULL,
	frame = SPR2_SPIN,
	tics = krework.chars.tails.settings.THROW_TIME,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_TAILSTHROW
}

states[S_PLAY_TAILSCAUGHT] = {action = nil,
	sprite = SPR_NULL,
	frame = SPR2_SPIN,
	tics = 2,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_JUMP
}

states[S_PLAY_TAILSTHROW] = {action = A_KRTailsThrow,
	sprite = SPR_PLAY,
	frame = SPR2_FLY,
	tics = 0,
	var1 = 0,
	var2 = 0,
	nextstate = S_PLAY_FALL
}

states[S_TAILS_WHIRLYGIG] = {action = nil,
	sprite = SPR_WIND,
	frame = A,
	tics = krework.chars.tails.settings.THROW_TIME,
	var1 = 0,
	var2 = 0,
	nextstate = S_DEATHSTATE
}

mobjinfo[MT_TAILS_WHIRLYGIG] = {
	doomednum = -1,
	spawnstate = S_TAILS_WHIRLYGIG,
	spawnhealth = 1000,
	reactiontime = 0,
	radius = 1,
	height = 1,
	mass = 0,
	flags = MF_NOGRAVITY|MF_NOCLIP
}

addHook("MobjThinker", function(mo)
	if mo.target
		P_TeleportMove(mo, mo.target.x, mo.target.y, mo.target.z)
		mo.angle = $ - ANGLE_90
		mo.angle = $ + (WHIRLYGIG_ROTATIONS * 360 / states[S_TAILS_WHIRLYGIG].tics * ANG1)
		P_TeleportMove(mo, mo.x + (64*cos(mo.angle)), mo.y + (64*sin(mo.angle)), mo.z)
		mo.angle = $ + ANGLE_90
		P_SpawnGhostMobj(mo)
	end
	mo.scale = FRACUNIT * 2/3
end, MT_TAILS_WHIRLYGIG)

states[S_FISTBUMP] = {action = nil,
	sprite = SPR_FBMP,
	frame = A,
	tics = 2,
	var1 = 0,
	var2 = 0,
	nextstate = S_DEATHSTATE
}

mobjinfo[MT_FISTBUMP] = {
	doomednum = -1,
	spawnstate = S_FISTBUMP,
	spawnhealth = 1000,
	reactiontime = 0,
	radius = 1,
	height = 1,
	mass = 0,
	flags = MF_NOGRAVITY|MF_NOCLIP
}