-- Super Tails whirlwind stuff
freeslot(
"S_TAILSWIND",
"MT_TAILSWIND"
)

function A_TailsWindThinker(actor)
	local scale = actor.scale
	local layer = actor.tracer
	
	-- Chained thinker for the spiralling dust column.
	while layer and layer.valid
		P_TeleportMove(layer, layer.x + 5 * FixedMul(scale, cos(layer.angle)), layer.y + 5 * FixedMul(scale, sin(layer.angle)), layer.z)
		layer.scale = scale
		layer.angle = $ + ANG10 / 2
		layer.momx = actor.momx
		layer.momy = actor.momy
		layer = layer.tracer
	end
	
	-- Spawn random dust around the column on the base.
	if P_IsObjectOnGround(actor)
		local dustang = P_RandomRange(0, 7)*ANGLE_45
		local dust = P_SpawnMobj(actor.x + 96 * FixedMul(scale, cos(dustang)), actor.y + 96 * FixedMul(scale, sin(dustang)), actor.z, MT_ARIDDUST)
		dust.state = dust.info.spawnstate + P_RandomRange(0, 2)
		dust.destscale = scale * 3
		P_SetScale(dust, dust.destscale)
		dust.color = actor.color
		dust.colorized = true
			
	end
	
	actor.extravalue1 = $ + 1
	if (actor.extravalue1 == 12)
		actor.extravalue1 = 0
		
		-- Create a set of items for the rising dust column
		for i = 0, 3
			local angle = ANGLE_90*i
			local px = actor.x + 70 * FixedMul(scale, cos(angle))
			local py = actor.y + 70 * FixedMul(scale, sin(angle))
			local pz = actor.z
			
			layer = P_SpawnMobj(px, py, pz, MT_DUSTLAYER)
			layer.momz = 5 * scale
			layer.angle = ANGLE_90 + ANGLE_90*i
			layer.extravalue1 = TICRATE * 3
			layer.color = actor.color
			layer.colorized = true
			
			-- Chain them
			layer.tracer = actor.tracer
			actor.tracer = layer
		end
	end
end
states[S_TAILSWIND] = {action = A_TailsWindThinker,
	sprite = SPR_WIND,
	frame = A,
	tics = 1,
	var1 = 0,
	var2 = 0,
	nextstate = S_TAILSWIND
}

mobjinfo[MT_TAILSWIND] = {
	doomednum = -1,
	spawnstate = S_TAILSWIND,
	spawnhealth = 1000,
	reactiontime = 0,
	radius = 80*FRACUNIT,
	height = 416*FRACUNIT,
	mass = 0,
	flags = MF_NOGRAVITY|MF_SPECIAL
}

addHook("TouchSpecial", function(touched, mo)
	print("collision")
	if not krework.checkExistence(mo.player)
	or not krework.checkCollisionHeight(mo, touched)
		return true
	end
	
	print("rising")
	mo.momz = 10*FRACUNIT
	return true
end, MT_TAILSWIND)
